function [ac,phistar,psi,sigeps,sigeta]=f_simparstarexlamda(y,ft,lam,phi_old,phistar_old,psi_old,sigeps_old,sigeta_old,psilag,philag,f_ind,p0,P0,q0,Q0,sigetanu0,sigetaS0,sigeps0,er0,utz,normp)

T=min(size(y,1),size(ft,1));
N=size(y,2);
nf=size(ft,2);
yt0=y(end-T+1:end,:);
ft0=ft(end-T+1:end,:);
ac=1;

%sigetam=sigeta_old;
sigetanu0=(N-er0)/2;%nf+2;%(N-er0)/2;%(nf+2); %degrees of freedom for inverse wishart prior for sig
sigetaS0=sigeta_old*(sigetanu0-(nf+1)/2); %

if ~f_ind
    phistar=randn(nf^2*philag,1);
elseif f_ind
    phistar=zeros(nf*philag,nf);
    phistar(find(phistar_old'))=randn(nf*philag,1);
end
psi=randn(N,psilag);
sigeps=zeros(N,1);
sigeta=eye(nf);

resi=yt0-ft0*lam';
xtild=permute(resi,[1 3 2]);
xtild_l=[];

if psilag
    % psi's and sigma's
    for j=1:psilag
        xtild_l=[xtild_l xtild(psilag+1-j:end-j,:,:)];
    end
    xtild=xtild(psilag+1:end,:,:);
    resi=resi(psilag+1:end,:);

    for j=1:N
        Qp=inv(sigeps_old(j)^(-1).*xtild_l(:,:,j)'*xtild_l(:,:,j)+Q0(:,:,j));
        qp=Qp*(sigeps_old(j)^(-1).*xtild_l(:,:,j)'*xtild(:,1,j)+Q0(:,:,j)*q0(j,:)');
        psi(j,:)= (qp +chol(Qp)'*psi(j,:)')';
               
    end
    ind=find(abs(sum(psi,2))>1);
    psi(ind,:)=psi_old(ind,:);
    resi=resi-reshape(sum(xtild_l.*permute(psi(:,:,ones(1,T-psilag)),[3 2 1]),2),T-psilag,N);
end

sigepspost=[sigeps0(:,1)+0.5*(T-psilag) sigeps0(:,2)+0.5*sum(resi.^2,1)'];
sigeps= 1./gamrnd(sigepspost(:,1),1./sigepspost(:,2));

if normp
[sigeta]=f_simsigeta(ft,phi_old,philag,sigetanu0,sigetaS0);
end

if philag
    [ve,va]=eig(sigeta);
    HI=ve*inv(sqrt(va))*ve';
    ftstar=(HI*ft')';
    ft0=ftstar;
    ftk=[];
    for j=1:philag
        ftk=[ftk ft0(philag+1-j:end-j,:)];
    end
    ft0=ft0(philag+1:end,:);
    ft0k=ft0;
    if ~f_ind
    ftk=kron(eye(nf),ftk);
    Pp=inv(ftk'*ftk+P0);
    pp=Pp*(ftk'*ft0k(:)+P0*p0);

    phistar=pp+chol(Pp)'*phistar;
    phistar=reshape(phistar,nf*philag,nf)';
    elseif f_ind
       for j=1:nf
            Pp=inv(ftk(:,[0:(philag-1)]*nf+j)'*ftk(:,[0:(philag-1)]*nf+j)+P0(:,:,j));
            pp=Pp*(ftk(:,[0:(philag-1)]*nf+j)'*ft0k(:,j)+P0(:,:,j)*p0(j,:)');
            phistar([0:(philag-1)]*nf+j,j)=pp+chol(Pp)'*phistar([0:(philag-1)]*nf+j,j);
       end
       phistar=phistar';
    end
            
    if any(abs(eig([phistar;eye(nf*(philag-1),nf*philag)]))>1)
        phistar=phistar_old;
    end
end

