function dat = qq(varargin)
%
% QQ  Quarterly dates.
%
% Syntax:
%   dat = qq(year)
%   dat = qq(year,quarter)
% Arguments:
%   dat numeric; year numeric; quarter numeric
%
% IRIS Toolbox 2006/10/13 

% function body ---------------------------------------------------------------------------------------------

year = varargin{1};
if nargin == 1, per = ones(size(year));
  else, per = varargin{2}; end

dat = datcode(year,per,4);

end % of primary function -----------------------------------------------------------------------------------