function [yret] = f_lagtrans(dat,lagvec,lagcoeff)
% procedure to premultiply a vector of variables dyt by a lag polynomial
% dyt*=phi(L)dyt 

nobs=size(dat,1);
nvar=size(dat,2);
nlags=max(lagvec);
phimat=lagcoeff';
nf=size(dat,2);
% Kind=1;
% for Iind=1:nvar;
%    for Jind=1:lagvec(Iind);
%       phimat(Jind,Iind)=lagcoeff(Kind);
%       Kind=Kind+1;
%    end;
% end;
yret=dat(1+nlags:nobs,:);
for Iind=1:nlags;
    yret=yret-dat(1+nlags-Iind:nobs-Iind,:)*phimat((Iind-1)*nf+1:nf*Iind,:);
end;


