function [delta_mat,ftstar_all,lamspar,tau,beta,rho,rhop,er0]=f_simparlamsparse(y,ft,lam_old,psi,sigeps,sigeta_old,tau_old,rho_old,psilag,tau0,beta0,rho0,prior,utz)

N=size(y,2);
nf=size(ft,2);

lamspar=zeros(N,nf);
tau=zeros(nf,1);
taup=tau0;
rho=zeros(nf,1);
rhop=[prod(rho0,2) rho0(:,1).*(1-rho0(:,2))];
beta=[];
if prior==2;
    beta=zeros(N,nf);
end
er0=1;

[ve,va]=eig(sigeta_old);
H_old=ve*sqrt(va)*ve';
HI_old=ve*inv(sqrt(va))*ve';
ftstar_all=(HI_old*ft')';
ftstar=ftstar_all(psilag+1:end,:,ones(1,N));
lamspar_old=lam_old*H_old;
% for j=1:philag;
%     phistar(:,(j-1)*nf+1:j*nf)= HI_old*phi_old(:,(j-1)*nf+1:j*nf)*H_old;
% end

if any(psilag);
    for j=1:nf;
    ftstar(:,j,:)=f_lagtrans_ind(squeeze(ftstar_all(:,j,ones(1,N))),psilag,psi); 
    end
end

T=min(size(ftstar,1),size(y,1));
y=y(end-T+1:end,:);
ftstar=ftstar(end-T+1:end,:,:);
lan0_mat=zeros(N,nf);

%sample lamspar_ij across j
for j=1:nf;  
    sim_ind=[1+(j-1)*utz:N];
    xstar=y-squeeze(sum(ftstar(:,[1:j-1 j+1:nf],:).*permute(lamspar_old(:,[1:j-1 j+1:nf],ones(1,T)),[3 2 1]),2));
    
    Mi= (squeeze(sum(ftstar(:,j,:).^2,1))./sigeps+(1/tau_old(j))).^-1;
    mi= Mi.*squeeze(sum(xstar.*squeeze(ftstar(:,j,:)),1))'./sigeps;
        
    pp=rho_old(j);
    if prior==2
        pp=pp*beta0(j,2);
    end
    podd=log(pp/(1-pp))+f_pmultnormlog(0,0,tau_old(j))-f_pmultnormlog(zeros(N,1),mi,Mi);
    podd=min(exp(podd)./(exp(podd)+1),1.0e+06/(1.0e+06+1));
        
    lan0=(rand(N-(j-1)*utz,1)<=podd(sim_ind));
    if utz
        lan0=[zeros(j-1,1)==1;lan0];
    end
    lan0_mat(:,j)=lan0;
    sim_lan=any(all(lan0_mat(:,1:j-1)==lan0(:,ones(1,j-1)),1));
    while or(all(~lan0),sim_lan)
        lan0=(rand(N-(j-1)*utz,1)<=podd(sim_ind));
        if utz
            lan0=[zeros(j-1,1)==1;lan0];
        end
        lan0_mat(:,j)=lan0;
        sim_lan=any(all(lan0_mat(:,1:j-1)==lan0(:,ones(1,j-1)),1));
    end
    rhoN=sum(lan0);
    lamspar(lan0,j)=mi(lan0)+sqrt(Mi(lan0)).*randn(sum(lan0),1);
    % lamspar_old(:,j)=lamspar(:,j);
    
    if prior==2;
    podd=(1-beta0(j,2))*rho_old(j)/(1-rho_old(j));
    podd=podd/(1+podd);
    ben0= (rand(N-sum(lan0)-(j-1)*utz,1))<=podd;
    if utz
        ben0=[zeros(j-1,1)==1;ben0];
    end
    simbe=find(~lan0);
    beta(simbe(ben0),j)=betarnd(kron(ones(sum(ben0),1),prod(beta0(j,:))),kron(ones(sum(ben0),1),beta0(j,1)*(1-beta0(j,2))+1));
    beta(lan0,j)=betarnd(kron(ones(sum(lan0),1),prod(beta0(j,:))+1),kron(ones(sum(lan0),1),beta0(j,1)*(1-beta0(j,2))));
    rhoN=sum(ben0)+sum(lan0);
    end
    
    taup(j,:)=taup(j,:) + [0.5*sum(lan0) 0.5*sum(lamspar(lan0,j).^2)];
    tau(j)=1./gamrnd(taup(j,1),1./taup(j,2));
    rhop(j,:)= rhop(j,:) + [ rhoN N-rhoN-(j-1)*utz];
    rho(j)=betarnd(rhop(j,1),rhop(j,2));
    if prior==2
        er0=er0*(1-rho(j)*mean(beta([simbe(ben0);find(lan0)],j)));
    elseif prior==1
        er0=er0*(1-rho(j));
    end
    if and(prior>0,j==nf);
        er0=round(N*er0);
    end
end

delta_mat=lan0_mat;

end