function [sample,flag] = getsample(y)
%
% UTILS/GETSAMPLE  Sample from first non-NaN to last non-NaN, check for within-sample NaNs.
%
% IRIS Toolbox 2006/07/14 

% function body ---------------------------------------------------------------------------------------------

sample = all(all(~isnan(y),3),1);
first = find(sample,1);
last = find(sample,1,'last');
sample(1:first-1) = false;
sample(last+1:end) = false;
flag = all(sample(first:last));
sample(first:last) = true;

end % of primary function -----------------------------------------------------------------------------------