function [yret] = f_lagtrans_ind(dat,lagvec,lagcoeff)
% procedure to premultiply a vector of variables dyt by a lag polynomial
% dyt*=phi(L)dyt 

nobs=size(dat,1);
nvar=size(lagcoeff,1);
nlags=max(lagvec);
phimat=lagcoeff';
% Kind=1;
% for Iind=1:nvar;
%    for Jind=1:lagvec(Iind);
%       phimat(Jind,Iind)=lagcoeff(Kind);
%       Kind=Kind+1;
%    end;
% end;
yret=dat(1+nlags:nobs,:);
for Iind=1:nlags;
    yret=yret-dat(1+nlags-Iind:nobs-Iind,:).*phimat(Iind*ones(1,nobs-nlags),:);
end;
