function ser_out = f_intcorrect(ser_in);
%
% shifts time series prior to log
%
% ser_in    (Tx1) vector of observations
%
% C Schumacher, 28 Nov 2005
%
ser_min = min(ser_in);
if (ser_min <= 0.0)
    ser_out = ser_in + (-1)*ser_min*1.10;
else
    ser_out = ser_in;
end

return
